<id>
Extended Profiles
</id>

<version>
Beta 4
</version>

<mod info>
Allows you do add an unlimited number of additional fields to user profiles.

This file is compatible with YaMS 4

Features:
- unlimited profile fields
- additional fields can be displayed on viewprofile, memberlist and post pages
- easily add, edit, reorder and remove fields in admin center
- 9 different field types:
  * textbox
  * textarea
  * dropdown list
  * radiobuttons
  * checkbox
  * date
  * email
  * url
  * spacer
- each field has the following settings available:
  * active
  * comment/description
  * required/visible on registration
  * visible in ViewProfile (including limitation for special users and/or groups!)
  * visible in Posts (including limitation for special users and/or groups!)
  * visible in Memberlist (including limitation for special users and/or groups!)
  * switch for editable by user or admin only
- special settings for a couple of types:
  * limit length
  * input box width
  * force numberic value
  * default value
  * allow ubbc
  * unlimited options for dropdown lists and radiobuttons
  * different spacer types (<br> and <hr>)
- highly compatible with other mods
- easy integration into your own code
- intelligent profile file handling to minimize disk usage (profiles equal to default get deleted)


Additional Installation Steps:
1. upload ExtendedProfiles.pl to your Sources folder, in ASCII mode, chmod 666
2. upload extended_profiles_fields.txt to your Variables folder, in ASCII mode, chmod 666
3. upload extended_profiles_order.txt to your Variables folder, in ASCII mode, chmod 666


For Developers:
  You can easily use Extended Profiles in your code.

  require "$sourcedir/ExtendedProfiles.pl";
  $value = ext_get($username,"fieldname");

  This will put the value of the field "fieldname" of the user $username into the variable $value.


Version History:
  Beta 4: - fixed conflicts with multiple date fields and birthday
  Beta 3: - "Invalid Character" error in textareas fixed
  Beta 2: - Changed search strings in Profile.pl to make the mod more compatible with other mods.


If you have questions or problems, please visit this site: http://boardmod.yabbforum.com/yabb/YaBB.pl?board=new_mods_beta;action=display;num=1041902328
</mod info>

<author>
Michael Prager
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
YaBB.pl
</edit file>

<search for>
#END FASTFIND *
</search for>

<add before>
	elsif ($action eq 'ext_admin') { require "$sourcedir/ExtendedProfiles.pl"; &ext_admin; }
	elsif ($action eq 'ext_edit') { require "$sourcedir/ExtendedProfiles.pl"; &ext_admin_edit; }
	elsif ($action eq 'ext_edit2') { require "$sourcedir/ExtendedProfiles.pl"; &ext_admin_edit2; }
	elsif ($action eq 'ext_create') { require "$sourcedir/ExtendedProfiles.pl"; &ext_admin_create; }
	elsif ($action eq 'ext_reorder') { require "$sourcedir/ExtendedProfiles.pl"; &ext_admin_reorder; }
</add before>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
    <table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$txt{'501'}</b></td>
</search for>

<add before>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= qq~
    <table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$lang_ext{'Profiles_Controls'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="1">
        - <a href="$cgi;action=ext_admin">$lang_ext{'admin_field'}</a>
        </font></td>
      </tr>
    </table><BR>
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
            $postinfo
</search for>

<add after>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_viewinposts($musername) . qq~
</add after>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
$TableHeader .= qq(
<table border=0 width=100% cellspacing=1 cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
);
</search for>

<add before>
require "$sourcedir/ExtendedProfiles.pl";
my $additional_headers = ext_memberlist_tableheader();
$membspan = $membspan + ext_memberlist_get_headercount($additional_headers);
</add before>

<search for>
$TableHeader .= qq(
</tr>
);
</search for>

<replace>
$TableHeader .= $additional_headers . qq(
</tr>
);
</replace>

<search for>
			$yymain .= qq~
			</tr>
			~;
		}
</search for>

<add before>
				$yymain .= ext_memberlist_tds($name);
</add before>

<search for>
			$yymain .= qq~
			</tr>
			~;
			}
</search for>

<replace>
			$yymain .= ext_memberlist_tds($membername) . qq~
			</tr>
			~;
			}
</replace>

<search for>
			$yymain .= qq~
			</tr>
			~;
			}
</search for>

<add before>
			$yymain .= ext_memberlist_tds($membername);
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
    </table><BR>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'597'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0 width="100%" cellpadding="3">
</search for>

<replace>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_editprofile($INFO{'username'},"required") . qq~
    </table><BR>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'597'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0 width="100%" cellpadding="3">
~;
$yymain .= ext_editprofile($INFO{'username'},"additional") . qq~
</replace>

<search for>
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
</search for>

<add before>
		require "$sourcedir/ExtendedProfiles.pl";
		my $error = &ext_validate_submition($member{'username'},$username);
		if ($error ne "") { &fatal_error($error); } else { &ext_saveprofile($member{'username'}); }

</add before>

<search for>
	                unlink("$memberdir/$member{'username'}.imconfig");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.ext");
</add after>

<search for>
	                unlink("$memberdir/$username.imconfig");
</search for>

<add after>
			unlink("$memberdir/$username.ext");
</add after>

<search for>
      </tr><tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
        <td><font size=2><b>$txt{'513'}:</b></font></td>
</search for>

<replace>
      </tr>
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_viewprofile($INFO{'username'}) . qq~<tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
        <td><font size=2><b>$txt{'513'}:</b></font></td>
</replace>

<edit file>
Sources/Register.pl
</edit file>

<search for>
$yymain .= qq~
    </table>
</search for>

<replace>
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= &ext_register . qq~
    </table>
</replace>

<search for>
	fopen(FILE, ">$memberdir/$member{'username'}.dat");
</search for>

<add before>
	require "$sourcedir/ExtendedProfiles.pl";
	my $error = &ext_validate_submition($member{'username'},$member{'username'});
	if ($error ne "") { &fatal_error($error); } else { &ext_saveprofile($member{'username'}); }

</add before>
